@if EXIST cleanup.bat @call cleanup
@REM ---------------------------------------------------------------------
@REM USER VARIABLES - SET TO SUIT YOUR ENVIRONMENT and TASTE
@REM =====================================================================
@REM THIS MUST BE CHANGED TO POINT TO THE VERSION OF GREP YOU WANT TO TEST
@REM =====================================================================
@set TEMPGREP=..\Release\grepw32\grepw32.exe
@REM set TEMPGREP=..\Debug\grepw32\grepw32.exe
@REM set TEMPGREP=C:\MDOS\grep.exe
@REM set error file
@set TEMPFIL=temperr.txt
@REM set NOISY
@REM set TEMPECH=echo
@REM or QUIET
@set TEMPECH=REM
@REM END USER VARIABLES
@REM =====================================================================

@REM These tests are based on those shown in Makefile.am
@REM TESTS = warning.sh khadafy.sh spencer1.sh bre.sh ere.sh pcre.sh
@REM        status.sh empty.sh options.sh backref.sh file.sh foad1.sh
@REM        fmbtest.sh yesno.sh

@echo Test GREP ... [%TEMPGREP%] ...
@if NOT EXIST %TEMPGREP% goto ERR1

@echo Now the TESTS ...
@echo Start %DATE% %TIME% > %TEMPFIL%
@echo Testing using %TEMPGREP% app ... VERSION is - >> %TEMPFIL%
@%TEMPGREP% --version >> %TEMPFIL%
@echo ====================================================== >> %TEMPFIL%
@set TEMPT=status.bat
@%TEMPECH% Using %TEMPT% ...
@echo Using %TEMPT% ... >> %TEMPFIL%
@if NOT EXIST %TEMPT% goto NO1
call %TEMPT%
@goto DN1
:NO1
@echo WARNING: Can not locate %TEMPT% ... Test not done ...
@echo WARNING: Can not locate %TEMPT% ... Test not done ... >> %TEMPFIL%
:DN1

@echo ====================================================== >> %TEMPFIL%
@set TEMPT=empty.bat
@%TEMPECH% Using %TEMPT% ...
@echo Using %TEMPT% ... >> %TEMPFIL%
@if NOT EXIST %TEMPT% goto NO2
call %TEMPT%
@goto DN2
:NO2
@echo WARNING: Can not locate %TEMPT% ... Test not done ...
@echo WARNING: Can not locate %TEMPT% ... Test not done ... >> %TEMPFIL%
:DN2

@echo ====================================================== >> %TEMPFIL%
@REM WARNING: This test requires a *** FILE COMPARE TOOL ***
@set TEMPT=khadafy.bat
@%TEMPECH% Using %TEMPT% ...
@echo Using %TEMPT% ... >> %TEMPFIL%
@if NOT EXIST %TEMPT% goto NO3
call %TEMPT%
@goto DN3
:NO3
@echo WARNING: Can not locate %TEMPT% ... Test not done ...
@echo WARNING: Can not locate %TEMPT% ... Test not done ... >> %TEMPFIL%
:DN3

@if EXIST gt.bat @call gt

@echo ====================================================== >> %TEMPFIL%
@set TEMPT=spencer1.bat
@%TEMPECH% Using %TEMPT% ...
@echo Using %TEMPT% ... >> %TEMPFIL%
@if NOT EXIST %TEMPT% goto NO4
call %TEMPT%
@goto DN4
:NO4
@echo WARNING: Can not locate %TEMPT% ... Test not done ...
@echo WARNING: Can not locate %TEMPT% ... Test not done ... >> %TEMPFIL%
:DN4

@echo ====================================================== >> %TEMPFIL%
@set TEMPT=spencer2.bat
@%TEMPECH% Using %TEMPT% ...
@echo Using %TEMPT% ... >> %TEMPFIL%
@if NOT EXIST %TEMPT% goto NO5
call %TEMPT%
@goto DN5
:NO5
@echo WARNING: Can not locate %TEMPT% ... Test not done ...
@echo WARNING: Can not locate %TEMPT% ... Test not done ... >> %TEMPFIL%
:DN5

@echo ====================================================== >> %TEMPFIL%
@set TEMPT=bre.bat
@%TEMPECH% Using %TEMPT% ...
@echo Using %TEMPT% ... >> %TEMPFIL%
@if NOT EXIST %TEMPT% goto NO6
call %TEMPT%
@goto DN6
:NO6
@echo WARNING: Can not locate %TEMPT% ... Test not done ...
@echo WARNING: Can not locate %TEMPT% ... Test not done ... >> %TEMPFIL%
:DN6

@echo ====================================================== >> %TEMPFIL%
@set TEMPT=file.bat
@%TEMPECH% Using %TEMPT% ...
@echo Using %TEMPT% ... >> %TEMPFIL%
@if NOT EXIST %TEMPT% goto NO7
call %TEMPT%
@goto DN7
:NO7
@echo WARNING: Can not locate %TEMPT% ... Test not done ...
@echo WARNING: Can not locate %TEMPT% ... Test not done ... >> %TEMPFIL%
:DN7


@echo.
@echo Also the output -
@echo The process tried to write to a nonexistent pipe. has been noted,
@echo and should be ignored for now ...
@echo Display of %TEMPFAIL% ERRORS ...
@echo End %DATE% %TIME% >> %TEMPFIL%
type %TEMPFIL%
@echo End Display of %TEMPFAIL% ERRORS ...
@echo.
@echo.
@echo Please, do not be alarmed if some of the tests failed.
@echo The batch file system is NOT as efficient as shell scripts for unix.
@echo. 
@echo You can try the test1.bat, or manually enter to test.
@echo If you are SURE it is a GREP error, the report them to 'bug-grep@gnu.org',
@echo with the line number, the name of the batch file,
@echo and grep version number 'grep --version'.
@%TEMPGREP% --version
@echo Thank You.
@goto END

:ERR1
@echo Can NOT locate %TEMPGREP% ... check name, and fix location ...
@goto END

:END
@REM goto CLEANUP
@REM This allows a particular batch to be run again, singularly ...
@goto ALLDONE

:CLEANUP
@REM CLEAN UP A LITTLE
@set TEMPCNT=
@set TEMPCOMP=
@set TEMPECH=
@set TEMPERR=
@set TEMPF=
@set TEMPFIL=
@set TEMPGREP=
@set TEMPO=
@set TEMPT=
@set TEMPFAIL=

:ALLDONE
